//=============================================================================
//                               CloseTrades_After_Account_Profit_Reached.mq4
//                                               Copyright  2007, Tradinator
//                                                    tradinator.fx@gmail.com
// 20Jul16 : Fixed by Derk 
//=============================================================================

#property copyright "Copyright  2007, Tradinator"
#property link      "tradinator.fx@gmail.com"
#property show_inputs

                                       
extern double	ProfitTarget	= 10.0;     // The amount of money profit at which you want to close ALL open trades.                                     
extern int 		Slippage		= 5;
extern int		Retries			= 5;
extern bool		RemoveWhenDone	= true;

//=============================================================================
// script start function
//=============================================================================
void start()
{
	while (true)
	{
		if (AccountProfit() >= ProfitTarget)
		{
			int total = OrdersTotal();
			for (int i=total; i >= 0; i--)
			{
				if (!OrderSelect(i, SELECT_BY_POS))
					continue;
				int type   = OrderType();
				
				bool result = false;
				
				for (int j=0; j < Retries; j++)
				{
					switch(type)
					{
						//Close opened long positions
						case OP_BUY       : result = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red);
							break;
						
						//Close opened short positions
						case OP_SELL      : result = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red);
							break;
						
						//Close pending orders
						case OP_BUYLIMIT  :
						case OP_BUYSTOP   :
						case OP_SELLLIMIT :
						case OP_SELLSTOP  : result = OrderDelete(OrderTicket());
					}
					
					if (result == false)
					{
						Alert("Order " , OrderTicket() , " failed to close. Error:" , GetLastError() );
						Sleep(3000);
					}  
					else 
						break;
				}
			}
			if (RemoveWhenDone)
				return;
		}
	}
}

